#include "AnimationObjectPool.h"
#include "Animation.h"

AnimationObjectPool::AnimationObjectPool() {

}

AnimationObjectPool::~AnimationObjectPool() {
	while (!recycledAnimations.empty()) {
		Animation* toDelete = recycledAnimations.top();
		recycledAnimations.pop();
		delete toDelete;
	}
}

Animation* AnimationObjectPool::RequestAnimation() {
	if (recycledAnimations.empty()) {
		return new Animation;
	}
	else {
		Animation* nAnim = this->recycledAnimations.top();
		this->recycledAnimations.pop();
		nAnim->RegisterToCurrentScene();
		return nAnim;
	}
}

void AnimationObjectPool::RecycleAnimation(Animation* tbr) {
	recycledAnimations.push(tbr);
}
