#include "Bullet.h"
#include "CentipedeBody.h"
#include "CentipedeHead.h"
#include "ProfileManager.h"
#include "Profile.h"
#include "ShootState.h"
#include "ShootState_Fire.h"
#include "ShootState_Attached.h"

Bullet::Bullet() {
	bitmap = &ResourceManager::GetTextureBitmap("bulletSprite");
	this->bulletSprite = sf::Sprite(ResourceManager::GetTexture("bulletSprite"));

	this->SetDrawOrder(5);
	this->SetUpdateOrder(1);
	SetCollider(bulletSprite, *bitmap);
	//RegisterCollision<Bullet>(*this);
	pShootState = nullptr;
	pShootStateFire = new ShootState_Fire(this);
	pShootStateAttached = new ShootState_Attached(this);
}

void Bullet::Initialize() {
	pShootState = pShootStateAttached;
}

void Bullet::DeInitialize() {

}

void Bullet::Update() {
	
	this->pShootState->Update();
	this->bulletSprite.setPosition(pos);

	if (pos.y < cn::BULLET_SPEED) MarkForDestroy();
}

void Bullet::Draw() {
	WindowManager::Window().draw(this->bulletSprite);
}



void Bullet::Destroy() {
	DeInitialize();
	DeregisterCollision<Bullet>(*this);
}

void Bullet::Shoot() {
	RegisterCollision<Bullet>(*this);
	//attachedToPlayer = false;
	pShootState = pShootStateFire;
}

void Bullet::Collision(Mushroom* other) {
	MarkForDestroy();
}

void Bullet::Collision(Scorpion* other) {
	MarkForDestroy();
}

void Bullet::Collision(Flea* other) {
	MarkForDestroy();
}

void Bullet::Collision(Spider* other) {
	MarkForDestroy();
}

void Bullet::Collision(CentipedeBody* other) {
	MarkForDestroy();
}

void Bullet::Collision(CentipedeHead* other) {
	MarkForDestroy();
}

Bullet::~Bullet() {
	delete pShootStateAttached;
	delete pShootStateFire;
}