#ifndef BULLET_H
#define BULLET_H

#include "Game Components/TEAL/CommonElements.h"

class Mushroom;
class Player;
class Scorpion;
class Flea;
class Spider;
class CentipedeBody;
class CentipedeHead;
class ShootState;

class Bullet : public GameObject
{
public:
	Bullet();
	Bullet(const Bullet&) = default;
	Bullet& operator=(const Bullet&) = default;
	~Bullet();
	virtual void Draw();
	virtual void Update();
	virtual void Destroy();
	void setPosition(sf::Vector2f nPos) { this->pos = nPos; }
	sf::Vector2f getPosition() { return pos; }
	virtual void Collision(GameObject* go) {};
	void Collision(Mushroom *other);
	void Collision(Scorpion* other);
	void Collision(Flea* other);
	void Collision(Spider* other);
	void Collision(CentipedeBody* other);
	void Collision(CentipedeHead* other);
	void Shoot();
	void Initialize();
	void DeInitialize();
private:
	sf::Sprite bulletSprite;
	CollisionTools::TextureBitmap *bitmap;
	sf::Vector2f pos;
	//bool attachedToPlayer;
	ShootState* pShootState;
	ShootState* pShootStateFire;
	ShootState* pShootStateAttached;
	
};

#endif

