#ifndef BULLET_MANAGER_H
#define BULLET_MANAGER_H

#include "Game Components/TEAL/CommonElements.h"
#include <vector>
class Bullet;
class BulletObjectPool;

class BulletManager
{
private:
	BulletManager();
	BulletManager(const BulletManager&) = delete;
	BulletManager& operator=(const BulletManager&) = delete;
	~BulletManager();
	static BulletManager* instance;
	static BulletManager& getInstance() {
		if (!instance)
			instance = new BulletManager();
		return *instance;
	}
public:
	//public static methods
	static void Terminate() { getInstance().privTerminate(); }
	static Bullet* RequestBullet() { return getInstance().privRequestBullet(); }
	static void RecycleBullet(GameObject* go) { getInstance().privRecycleBullet(go); }
	static bool IsAtMaxBullets() { return getInstance().privIsAtMaxBullets(); }
	static void KillAllBullets() {  getInstance().privKillAllBullets(); }
private:
	//private non-static methods
	void privTerminate();

	void privKillAllBullets();
	Bullet* privRequestBullet();
	void privRecycleBullet(GameObject*); 
	bool privIsAtMaxBullets();

	Bullet* GetBullet();

	//private helper functions

private:
	//private members
	int BulletCount;
	bool BulletExcessRequest;
	BulletObjectPool* pPool;
	std::vector<Bullet*> liveBullets;
	
};

#endif