#ifndef CENTIPEDE_H
#define CENTIPEDE_H

#include "Game Components/TEAL/CommonElements.h"
#include "CentipedeSegment.h"
#include <vector>

class CentipedeManager;
class CentipedeSegment;

struct CentipedeNode {
	CentipedeNode() : pNext(nullptr), pPrev(nullptr), pSeg(nullptr) {}
	CentipedeNode(const CentipedeNode&) = default;
	CentipedeNode& operator=(const CentipedeNode&) = default;
	~CentipedeNode() = default;

	CentipedeNode* pNext;
	CentipedeNode* pPrev;
	CentipedeSegment* pSeg;
};

class Centipede
{
public:
	Centipede();
	Centipede(const Centipede&) = default;
	Centipede& operator=(const Centipede&) = default;
	~Centipede();

	void Update();
	void SplitUpdate();
	void Initialize(int, int, bool);
	void Deinitialize();
	void InitializeWithData(CentipedeNode* pHead, CentipedeNode* pEnd);

	void requestSplit(CentipedeSegment* go) { splitRequested = true; splitRequestedAt.push_back(go); }
	void requestHeadKill() { headKillRequested = true; }
	CentipedeNode* getHead() { return pCentipedeHead; }
	CentipedeNode* getEnd() { return pCentipedeEnd; }
	void setHead(CentipedeNode* pNode) { this->pCentipedeHead = pNode; }
	void setEnd(CentipedeNode* pNode) { this->pCentipedeEnd = pNode; }
	void Split(CentipedeSegment*);
	void KillHead();
	void KillAll();
private:
	CentipedeNode* pCentipedeHead;
	CentipedeNode* pCentipedeEnd;
	CentipedeNode* findNode(CentipedeSegment*);
	bool splitRequested;
	std::vector<CentipedeSegment*> splitRequestedAt;
	bool headKillRequested;
};

#endif