#include "CentipedeSegment.h"
#include "MoveState.h"
#include "MoveFSM.h"
#include "MoveState_DownSwitchLeft.h"
#include "MoveState_DownSwitchRight.h"
#include "OffsetCollection.h"
#include "Centipede.h"

#include "MoveState_DownSwitchLeft.h"
#include "MoveState_DownSwitchRight.h"
#include "MoveState_PoisonedLeft.h"
#include "Bullet.h"

CentipedeSegment::CentipedeSegment(){
	this->SetDrawOrder(1);
	
	
}

void CentipedeSegment::Initialize(Centipede* pCent, int spd, int gpos) {
	this->cSprite.SetFrame(0);
	frameCounter = 0;
	this->pCentipede = pCent;
	this->speed = spd;
}

void CentipedeSegment::nextGridFrame() {
	frameCounter = 0;
	this->gridPos.x += this->pMoveState->getGridOffsets()->x;
	this->gridPos.y += this->pMoveState->getGridOffsets()->y;
	//movestate is changed depending on child;
}


Centipede* CentipedeSegment::getMother() {
	return pCentipede;
}

void CentipedeSegment::Draw() {
	WindowManager::Window().draw(this->cSprite);
}

void CentipedeSegment::Update() {
	
	this->cPos.x += this->pMoveState->getMoveOffsets(frameCounter, this->speed).x;
	this->cPos.y += this->pMoveState->getMoveOffsets(frameCounter, this->speed).y;
	//Trace::out("Centipede Pos: (%f, %f)\n", this->cPos.x, this->cPos.y);
	frameCounter++;
	this->cSprite.Update();
	this->cSprite.setPosition(this->cPos);
}



void CentipedeSegment::InheritMovement(const CentipedeSegment* other) {
	this->pMoveState = other->pMoveState;
}

void CentipedeSegment::Destroy() {
	
}

void CentipedeSegment::fall() {
	pMoveState = &MoveFSM::POISONED_LEFT;
}

