#ifndef CENTIPEDE_SEGMENT_H
#define CENTIPEDE_SEGMENT_H



#include "Game Components/TEAL/CommonElements.h"
#include "MushroomField.h"

class MoveState;
class Bullet;
class Centipede;
class ScoreCommand;


//
//enum class CENTIPEDE_SEGMENT_TYPE: unsigned char {
//
//};

class CentipedeSegment : public GameObject {
public:
	CentipedeSegment();
	CentipedeSegment(const CentipedeSegment&) = default;
	CentipedeSegment& operator=(const CentipedeSegment&) = default;
	~CentipedeSegment() = default;

	virtual void Initialize(Centipede*, int, int);
	virtual void Update();
	virtual void Draw();
	virtual void Destroy();
	virtual void DeInitialize() = 0;
	sf::Vector2<char> getGridPos() { return gridPos; }
	char getGridX() { return gridPos.x; }
	char getGridY() { return gridPos.y; }
	virtual void nextGridFrame();
	virtual void assureGridFrame() {}
	void InheritMovement(const CentipedeSegment* other);
	Centipede* getMother();
	void setMother(Centipede* mama) { this->pCentipede = mama; }
	sf::Vector2f getPos() { return cPos; }
	const MoveState* getMoveState() { return pMoveState; }
	void fall();
	int getSpeed() { return speed; }
protected:
	sf::Vector2<char> gridPos;
	AnimatedSprite cSprite;
	CollisionTools::TextureBitmap* bitmap;
	sf::Vector2f cPos;
	const MoveState* pMoveState;
	char frameCounter;
	Centipede* pCentipede;
	ScoreCommand* pDeath;
	int speed;
};

#endif