#include "CentipedeSegmentObjectPool.h"
#include "CentipedeBody.h"
#include "CentipedeHead.h"

CentipedeSegmentObjectPool::CentipedeSegmentObjectPool() {

}

CentipedeBody* CentipedeSegmentObjectPool::requestCentipedeBody() {
	CentipedeBody* ret;
	if (this->recycledBodies.empty()) {
		ret = new CentipedeBody();
	}
	else {
		ret = this->recycledBodies.top();
		this->recycledBodies.pop();
		ret->RegisterToCurrentScene();
	}
	return ret;
}

CentipedeHead* CentipedeSegmentObjectPool::requestCentipedeHead() {
	CentipedeHead* ret;
	if (this->recycledHeads.empty()) {
		ret = new CentipedeHead();
		//Trace::out("Making New Head: %p\n", ret);
	}
	else {
		//Trace::out("recycling head.\n");
		ret = this->recycledHeads.top();
		this->recycledHeads.pop();
		ret->RegisterToCurrentScene();
		//Trace::out("Recycling Old Head: %p\n", ret);
	}
	return ret;
}

void CentipedeSegmentObjectPool::recycleCentipedeBody(CentipedeBody* obj) {
	//Trace::out("Sent %p (BODY) back to the factory.\n", obj);
	this->recycledBodies.push(obj);
}


void CentipedeSegmentObjectPool::recycleCentipedeHead(CentipedeHead* obj) {
	//Trace::out("Sent %p (HEAD) back to the factory.\n", obj);
	this->recycledHeads.push(obj);
}

CentipedeSegmentObjectPool::~CentipedeSegmentObjectPool() {
	while (!this->recycledBodies.empty()) {
		CentipedeBody* tmpBody = this->recycledBodies.top();
		this->recycledBodies.pop();
		delete tmpBody;
	}
	while (!this->recycledHeads.empty()) {
		CentipedeHead* tmpHead = this->recycledHeads.top();
		this->recycledHeads.pop();
		delete tmpHead;
	}
}