#ifndef CENTIPEDE_SEGMENT_OBJECT_POOL_H
#define CENTIPEDE_SEGMENT_OBJECT_POOL_H

#include "Game Components/TEAL/CommonElements.h"
#include <stack>

class CentipedeBody;
class CentipedeHead;

class CentipedeSegmentObjectPool
{
public:
	CentipedeSegmentObjectPool();
	CentipedeSegmentObjectPool(const CentipedeSegmentObjectPool&) = default;
	CentipedeSegmentObjectPool& operator=(const CentipedeSegmentObjectPool&) = default;
	~CentipedeSegmentObjectPool();

	CentipedeBody* requestCentipedeBody();
	CentipedeHead* requestCentipedeHead();

	void recycleCentipedeBody(CentipedeBody*);
	void recycleCentipedeHead(CentipedeHead*);
private:
	std::stack<CentipedeBody*> recycledBodies;
	std::stack<CentipedeHead*> recycledHeads;
};

#endif