#ifndef CRITTER_FACTORY_H
#define CRITTER_FACTORY_H

#include "Game Components/TEAL/CommonElements.h"
#include "SFML/Graphics.hpp"
#include "CritterObjectPool.h"

class Scorpion;
class Flea;
class Spider;
class Critter;
class CritterObjectPool;
class GameObject;

class CritterFactory {
private:
	CritterFactory();
	CritterFactory(const CritterFactory&) = delete;
	CritterFactory& operator=(const CritterFactory&) = delete;
	~CritterFactory() = default;
	static CritterFactory* instance;
	static CritterFactory& getInstance() {
		if (!instance)
			instance = new CritterFactory();
		return *instance;
	}
public:
	static void Update() { getInstance().privUpdate(); }
	static void Terminate() { getInstance().privTerminate(); }
	static void killAllCritters() { getInstance().privKillAllCritters(); }
	//public static scorpions
	static Scorpion* requestScorpion() { return getInstance().privRequestScorpion(); }
	static void recycleScorpion(GameObject* go) { getInstance().privRecycleScorpion(go); }
	//public static fleas
	static Flea* requestFlea() { return getInstance().privRequestFlea(); }
	static void recycleFlea(GameObject* go) { getInstance().privRecycleFlea(go); }
	//public static spiders
	static Spider* requestSpider() { return getInstance().privRequestSpider(); }
	static void recycleSpider(GameObject* go) { getInstance().privRecycleSpider(go); }
	//sets
private:
	//scorpion requests
	void privRecycleScorpion(GameObject*);
	Scorpion* privRequestScorpion();
	//flea requests
	void privRecycleFlea(GameObject*);
	Flea* privRequestFlea();
	//spider requests
	void privRecycleSpider(GameObject*);
	Spider* privRequestSpider();

	void privUpdate();
	void privTerminate();
	void privKillAllCritters();
	
	
};


#endif

