#include "CritterObjectPool.h"

CritterObjectPool::CritterObjectPool() {

}




CritterObjectPool::~CritterObjectPool() {
	while (!this->recycledScoprions.empty()) {
		Scorpion* delScorpion = this->recycledScoprions.top();
		this->recycledScoprions.pop();
		delete delScorpion;
	}
	while (!this->recycledFleas.empty()) {
		Flea* delFlea = this->recycledFleas.top();
		this->recycledFleas.pop();
		delete delFlea;
	}
	while (!this->recycledSpiders.empty()) {
		Spider* delSpider = this->recycledSpiders.top();
		this->recycledSpiders.pop();
		delete delSpider;
	}
}

void CritterObjectPool::privTerminate() {
	delete instance;
}


CritterObjectPool* CritterObjectPool::instance = nullptr;


void CritterObjectPool::privReturnScorpion(Scorpion* obj) {
	recycledScoprions.push(obj);
	//Trace::out("ScorpionPoolSize: %d\n", recycledScoprions.size());
}

Scorpion* CritterObjectPool::privGetScorpion() {
	if (recycledScoprions.empty()) {
		//Trace::out("Created a new scorpion\n");
		return new Scorpion();
	}
	Scorpion* nScor = this->recycledScoprions.top();
	this->recycledScoprions.pop();
	//Trace::out("Recycled an old scorpion\n");
	nScor->RegisterToCurrentScene();
	return nScor;
}

void CritterObjectPool::privReturnFlea(Flea* obj) {
	recycledFleas.push(obj);
}

Flea* CritterObjectPool::privGetFlea() {
	if (recycledFleas.empty()) {
		//Trace::out("Created a new Flea\n");
		return new Flea();
	}
	Flea* nFlea = this->recycledFleas.top();
	this->recycledFleas.pop();
	//Trace::out("Recycled an old flea\n");
	nFlea->RegisterToCurrentScene();
	return nFlea;
}

void CritterObjectPool::privReturnSpider(Spider* obj) {
	recycledSpiders.push(obj);
}

Spider* CritterObjectPool::privGetSpider() {
	if (recycledSpiders.empty()) {
		//Trace::out("Created a new Spider\n");
		return new Spider();
	}
	Spider* nSpider = this->recycledSpiders.top();
	this->recycledSpiders.pop();
	//Trace::out("Recycled an old spider\n");
	nSpider->RegisterToCurrentScene();
	return nSpider;
}