#include "GlyphSheet.h"
#include "Glyph.h"

GlyphSheet::GlyphSheet(sf::Texture& tex, int cch, int ccv) {
	mainSprite = sf::Sprite(tex);
	int cellWidth = tex.getSize().x/cch;
	int cellHeight = tex.getSize().y/ccv;
	for (int j = 0; j < ccv; j++) {
		for (int i = 0; i < cch; i++) {
			cells.push_back(sf::IntRect(i * cellWidth, j * cellHeight, cellWidth, cellHeight));
		}
	}
}

void GlyphSheet::Draw(int i, sf::Vector2f pos) {
	//temporary until I reason through how to implement draw correctly.
	sf::Sprite toShow = sf::Sprite(*mainSprite.getTexture(), cells.at(i));
	toShow.setPosition(pos);
	WindowManager::Window().draw(toShow);
}

Glyph GlyphSheet::GetGlyph(char c, sf::Vector2f npos) {
	return Glyph(this, CharToIndex(c), npos);
}


