#ifndef GRID_OBJECT_H
#define GRID_OBJECT_H

#include "Game Components/TEAL/CommonElements.h"

class GridObject : public GameObject
{
public:
	GridObject() {}
	GridObject(const GridObject&) = default;
	GridObject& operator=(const GridObject&) = default;
	~GridObject() {}

	virtual void Initialize(sf::Vector2f) = 0;
	virtual void Draw() = 0;
	virtual void Destroy() = 0;
	virtual void Collision(GameObject* go) = 0;
	virtual sf::Vector2f getPos() { return pos; }

	virtual void poisonThis() = 0;
	virtual bool isPoisoned() = 0;
	virtual void HealToFull() = 0;

	virtual void Activate() = 0;
	virtual void Deactivate() = 0;
protected:
	CollisionTools::TextureBitmap* bitmap;
	sf::Vector2f pos;
};

#endif