#ifndef HIGH_SCORE_MANAGER_H
#define HIGH_SCORE_MANAGER_H

#include "Game Components/TEAL/CommonElements.h"
#include <list>
#include <tuple>


class HighScoreManager
{
private:
	HighScoreManager();
	HighScoreManager(const HighScoreManager&) = delete;
	HighScoreManager& operator=(const HighScoreManager&) = delete;
	~HighScoreManager();
	static HighScoreManager* instance;
	static HighScoreManager& getInstance() {
		if (!instance)
			instance = new HighScoreManager();
		return *instance;
	}
public:
	//public static functions
	static void Terminate() { getInstance().privTerminate(); }
	static void LoadScores() { getInstance().privLoadScores(); }
	static std::list<std::pair<int, char[4]>> GetHighScoresList() { return getInstance().highScoresList; }
	static bool CheckForNewHighScores() { return getInstance().privCheckForNewHighScores(); }
	static bool HigherThanHighScore(int val) { return getInstance().privHigherThanHighScore(val); }
	static int GetHighScore() { return getInstance().highestScore; }
	static void AddHighScore(char inits[4]) { getInstance().privAddHighScore(inits); }
	static bool CheckForNewHighScoresBoth() { return getInstance().privCheckForNewHighScoresBoth(); }
private:
	//private non-static functions
	void privTerminate();
	void privLoadScores();
	bool privCheckForNewHighScores();
	bool privHigherThanHighScore(int);
	void privAddHighScore(char[4]);
	void PopulateFilesOnExit();
	bool privCheckForNewHighScoresBoth();
private:
	//helper functions
	void ReadInHighScores(char*);
	//private members
	std::list<std::pair<int, char[4]>> highScoresList;
	int highestScore;

};

#endif