#ifndef GAMECONTROLLER_H
#define GAMECONTROLLER_H

#include "Game Components/TEAL/CommonElements.h"

class Player;
class CritterController;

enum class CONTROLLER_TYPE: unsigned char {
	KEYBOARD,
	JOYSTICK,
	XBOX,
	AI,
	HIGHSCORE
};


class InputController : public GameObject
{
public:
	InputController();
	InputController(InputController const&) = default;
	InputController& operator=(InputController const&) = default;
	~InputController() = default;

	InputController(CONTROLLER_TYPE);
	virtual void Update();
	virtual void KeyPressed(sf::Keyboard::Key k, bool altKey, bool ctrlKey, bool shiftKey, bool systemKey);
	virtual void TextEntered(sf::Uint32);

	void changeInputType(CONTROLLER_TYPE);
private:
	void(*UpdateProxy)();
	static void UpdateKeyboard();
	static void UpdateJoystick();
	static void UpdateXBOX();
	static void UpdateAI();
	static void UpdateHighScore();
};


#endif
