#include "MainScene.h"
#include "Ship.h"
#include "Mushroom.h"
#include "Bullet.h"
#include "InputController.h"
#include "MushroomField.h"
#include "Definitions.h"
#include "Critter.h"
#include "CritterController.h"
#include "CentipedeBody.h"
#include "CentipedeHead.h"

void MainScene::Initialize() {
	
	WindowManager::SetBackgroundColor(sf::Color(0, 0, 0, 255));

	gm = new GameManagerUpdater();


	CollisionTestPair<Bullet, Mushroom>();
	CollisionTestPair<Ship, Mushroom>();
	CollisionTestPair<Bullet, Scorpion>();
	CollisionTestPair<Bullet, Flea>();
	CollisionTestPair<Ship, Flea>();
	CollisionTestPair<Bullet, Spider>();
	CollisionTestPair<Ship, Spider>();
	CollisionTestPair<Spider, Mushroom>();
	CollisionTestPair<Bullet, CentipedeBody>();
	CollisionTestPair<Bullet, CentipedeHead>();
	CollisionTestPair<Ship, CentipedeBody>();
	CollisionTestPair<Ship, CentipedeHead>();
}

void MainScene::Terminate() {
	gm->Terminate();
	gm->MarkForDestroy();
}