#include "MoveState_DownSwitchLeft.h"
#include "MoveState_DownSwitchRight.h"
#include "MoveState_UpSwitchRight.h"
#include "MoveState_LeftDown.h"
#include "MoveState_PoisonedRight.h"
#include "MushroomFieldManager.h"

MoveState_DownSwitchLeft::MoveState_DownSwitchLeft() {
	this->offsetArray = &OffsetCollection::TurnDownEndLeft;
	this->gridOffsetArray = &OffsetCollection::TurnDownEndLeft_g;
}
const MoveState* MoveState_DownSwitchLeft::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() - 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_LEFT_DOWN;
	}
	else {
		if (MushroomFieldManager::GetCurrentField()->isPoisoned(col, row))
			pNextState = &MoveFSM::POISONED_RIGHT;
		else if (row ==  cn::MUSHROOM_FIELD_ROWS)
			pNextState = &MoveFSM::SWITCH_RIGHT_UP;
		else
			pNextState = &MoveFSM::SWITCH_RIGHT_DOWN;
	}
	return pNextState;
}