#include "MoveState_DownSwitchRight.h"
#include "MoveState_RightDown.h"
#include "MoveState_DownSwitchLeft.h"
#include "MoveState_UpSwitchLeft.h"
#include "MoveState_PoisonedLeft.h"
#include "MushroomFieldManager.h"

MoveState_DownSwitchRight::MoveState_DownSwitchRight() {
	this->offsetArray = &OffsetCollection::TurnDownEndRight;
	this->gridOffsetArray = &OffsetCollection::TurnDownEndRight_g;
}
const MoveState* MoveState_DownSwitchRight::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() + 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_RIGHT_DOWN;
	}
	else {
		if (MushroomFieldManager::GetCurrentField()->isPoisoned(col, row))
			pNextState = &MoveFSM::POISONED_LEFT;
		else if (row == cn::MUSHROOM_FIELD_ROWS)
			pNextState = &MoveFSM::SWITCH_LEFT_UP;
		else
			pNextState = &MoveFSM::SWITCH_LEFT_DOWN;
	}
	return pNextState;
}