#include "MoveState_LeftDown.h"
#include "MoveState_DownSwitchRight.h"
#include "MoveState_UpSwitchRight.h"
#include "MoveState_PoisonedRight.h"
#include "MushroomFieldManager.h"

MoveState_LeftDown::MoveState_LeftDown() {
	this->offsetArray = &OffsetCollection::StraightLeft;
	this->gridOffsetArray = &OffsetCollection::StraightLeft_g;
}

const MoveState* MoveState_LeftDown::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() - 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_LEFT_DOWN;
	}
	else {
		if (MushroomFieldManager::GetCurrentField()->isPoisoned(col, row))
			pNextState = &MoveFSM::POISONED_RIGHT;
		else if (row == cn::MUSHROOM_FIELD_ROWS-1)
			pNextState = &MoveFSM::SWITCH_RIGHT_UP;
		else
			pNextState = &MoveFSM::SWITCH_RIGHT_DOWN;
	}
	return pNextState;
}