#include "MoveState_RightDown.h"
#include "MoveState_DownSwitchLeft.h"
#include "MoveState_PoisonedLeft.h"
#include "MoveState.h"
#include "MushroomFieldManager.h"

MoveState_RightDown::MoveState_RightDown() {
	this->offsetArray = &OffsetCollection::StraightRight;
	this->gridOffsetArray = &OffsetCollection::StraightRight_g;
}

const MoveState* MoveState_RightDown::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() + 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_RIGHT_DOWN;
	}
	else {
		if (MushroomFieldManager::GetCurrentField()->isPoisoned(col, row))
			pNextState = &MoveFSM::POISONED_LEFT;
		else if (row == cn::MUSHROOM_FIELD_ROWS-1)
			pNextState = &MoveFSM::SWITCH_LEFT_UP;
		else
			pNextState = &MoveFSM::SWITCH_LEFT_DOWN;
	}
	return pNextState;
}