#include "MoveState_UpSwitchLeft.h"
#include "MoveState_DownSwitchRight.h"
#include "MoveState_UpSwitchRight.h"
#include "MoveState_LeftUp.h"
#include "MushroomFieldManager.h"

MoveState_UpSwitchLeft::MoveState_UpSwitchLeft() {
	this->offsetArray = &OffsetCollection::TurnUpEndLeft;
	this->gridOffsetArray = &OffsetCollection::TurnUpEndLeft_g;
}
const MoveState* MoveState_UpSwitchLeft::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() - 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_LEFT_UP;
	}
	else {
		if (row == cn::PLAYER_GRID_HEIGHT_LIMIT)
			pNextState = &MoveFSM::SWITCH_RIGHT_DOWN;
		else
			pNextState = &MoveFSM::SWITCH_RIGHT_UP;
	}
	return pNextState;
}