#include "MoveState_UpSwitchRight.h"
#include "MoveState_RightUp.h"
#include "MoveState_DownSwitchLeft.h"
#include "MoveState_UpSwitchLeft.h"
#include "MushroomFieldManager.h"

MoveState_UpSwitchRight::MoveState_UpSwitchRight() {
	this->offsetArray = &OffsetCollection::TurnUpEndRight;
	this->gridOffsetArray = &OffsetCollection::TurnUpEndRight_g;
}
const MoveState* MoveState_UpSwitchRight::GetNextState(CentipedeSegment* cSeg) const {
	const MoveState* pNextState;
	char row = cSeg->getGridY();
	char col = cSeg->getGridX() + 1;
	bool blocked = MushroomFieldManager::GetCurrentField()->isBlocked(col, row);
	if (!blocked) {
		pNextState = &MoveFSM::MOVE_RIGHT_UP;
	}
	else {
		if (row == cn::PLAYER_GRID_HEIGHT_LIMIT)
			pNextState = &MoveFSM::SWITCH_LEFT_DOWN;
		else
			pNextState = &MoveFSM::SWITCH_LEFT_UP;
	}
	return pNextState;
}