#ifndef MUSHROOM_H
#define MUSHROOM_H

#include "Game Components/TEAL/CommonElements.h"
#include "Bullet.h"
#include "GridObject.h"
//#include "Player.h"
//#include "MushroomField.h"
//#include "Definitions.h"

class Bullet;
class Player;
class MushroomField;
class Spider;
class ScoreCommand;

class Mushroom : public GridObject
{
public:
	Mushroom();
	Mushroom(const Mushroom&) = default;
	Mushroom& operator=(const Mushroom&) = default;
	~Mushroom();

	virtual void Initialize(sf::Vector2f) override;
	virtual void Draw();
	virtual void Update();
	virtual void Destroy() override;
	virtual void Collision(GameObject* go) {};
	void Collision(Bullet *other);
	void Collision(Player* other);
	void Collision(Spider* other);
	void poisonThis();
	bool isPoisoned() { return poisoned; }
	void HealToFull();
	void Activate();
	void Deactivate();
private:
	char hp;
	bool poisoned;
	AnimatedSprite mushroomSprite;
	void updateSprite();
	ScoreCommand* pDeath;
	ScoreCommand* pRegenerate;
	bool shouldDraw;
};

#endif

