#ifndef MUSHROOM_CONTROLLER_H
#define MUSHROOM_CONTROLLER_H

#include "Game Components/TEAL/CommonElements.h"
#include "MushroomField.h"



class GridObject;

class MushroomController {
private:
	MushroomController();
	MushroomController(const MushroomController&) = delete;
	MushroomController& operator=(const MushroomController&) = delete;
	~MushroomController();
	static MushroomController* instance;
	static MushroomController& getInstance() {
		if (!instance)
			instance = new MushroomController();
		return *instance;
	}
private:
	//private non-static functions
	void privTerminate();
	GridObject* privRequestMushroom(sf::Vector2f);
	void privRecycleMushroom(GameObject*);
public:
	//public static mushroom functions
	static GridObject* requestMushroom(sf::Vector2f pos) { return getInstance().privRequestMushroom(pos); }
	static void recycleMushroom(GameObject* go) { getInstance().privRecycleMushroom(go); }
	static void Terminate() { getInstance().privTerminate(); }


	
};

#endif