#ifndef MUSHROOMFIELD_H
#define MUSHROOMFIELD_H

#include "Game Components/TEAL/CommonElements.h"

#include <stdlib.h>
#include <time.h>
//#include <rpc.h>
#include "Definitions.h"

class GridObject;


class MushroomField : public GameObject {
public:
	MushroomField();
	MushroomField(MushroomField const &) = default;
	MushroomField& operator=(MushroomField const &) = default;
	~MushroomField();
	void removeMushroomFromField(sf::Vector2<unsigned char> const vector);
	void removeMushroomFromField(sf::Vector2f const);
	void generateField();
	void generateAttractorField();
	//Mushroom* getMushroom(unsigned char, unsigned char);
	bool isBlocked(char, char);
	bool isPoisoned(char, char);
	GridObject* getMushroom(unsigned char, unsigned char);
	GridObject* getMushroom(sf::Vector2<unsigned char>);
	void spawnMushroom(unsigned char, unsigned char);
	void spawnBarrier(unsigned char, unsigned char);
	void newGame();
	void newGameAI();
	void PoisonRequest(sf::Vector2<char>);
	void Regenerate();
	void RegenerateColumn(int);
	int GetLowerCount() { return mushroomCountLowerQuadrant;}
	void DeactivateField();
	void ActivateField();
	void Test();
	void ReplaceSpaceWithBarrier(unsigned char, unsigned char);
	void HighScoreDelete();
	void NewRound();
private:
	GridObject*** pField; 
	int mushroomCount;
	int mushroomCountLowerQuadrant;
	sf::Vector2f convertGridToPosition(sf::Vector2<unsigned char> const vector);
	sf::Vector2<unsigned char> convertPositionToGrid(sf::Vector2f const);
	void killAllMushrooms();
};

#endif

