#include "MushroomFieldManager.h"
#include "MushroomField.h"
#include "WaveManager.h"
#include "Wave.h"
#include "ProfileManager.h"

MushroomFieldManager::MushroomFieldManager() {
	pCurrentField = nullptr;
}

MushroomFieldManager::~MushroomFieldManager() {

}

MushroomFieldManager* MushroomFieldManager::instance = nullptr;

MushroomField* MushroomFieldManager::privGetCurrentField() {
	return this->pCurrentField;
}

void MushroomFieldManager::privCreateNewField() {
	p1Field = new MushroomField();
	p2Field = new MushroomField();
	pCurrentField = p1Field;
}

void MushroomFieldManager::privTerminate() {
	delete instance;
}

void MushroomFieldManager::privNewGame() {

	pCurrentField = p1Field;
	p1Field->newGame();
	p2Field->newGame();
	//p2Field->Test();
	p2Field->DeactivateField();
	p1Field->ActivateField();
	
}

void MushroomFieldManager::privNewGameAI() {
	pCurrentField = p1Field;
	p1Field->newGameAI();
	p2Field->DeactivateField();
	p1Field->ActivateField();
}

void MushroomFieldManager::privRemoveMushroomFromCurrentField(sf::Vector2f pos) {
	pCurrentField->removeMushroomFromField(pos);
}

void MushroomFieldManager::privAddMushroomToCurrentField(sf::Vector2<char> pos) {
	pCurrentField->spawnMushroom(pos.x, pos.y);
}

void MushroomFieldManager::privPoisonMushroomOnCurrentField(sf::Vector2<char> pos) {
	pCurrentField->PoisonRequest(pos);
}

bool MushroomFieldManager::privDoWeNeedAFlea() {
	if (pCurrentField->GetLowerCount() <= WaveManager::GetCurrentWave()->getFleaTriggerValue())
		return true;
	else
		return false;
}

void MushroomFieldManager::privRegenerateCurrentField() {
	pCurrentField->Regenerate();
}

void MushroomFieldManager::privRegenerateCurrentColumn(int col) {
	pCurrentField->RegenerateColumn(col);
}

void MushroomFieldManager::privNewRound() {
	this->p1Field->NewRound();
	this->p2Field->NewRound();
}

void MushroomFieldManager::privUpdateCurrentField() {
	if (ProfileManager::GetFieldIDFromCurrentPlayer() == 1) {
		pCurrentField = p1Field;
		p1Field->ActivateField();
		p2Field->DeactivateField();
		//Trace::out("Swap to Field 1\n");
	}
	else {
		pCurrentField = p2Field;
		p2Field->ActivateField();
		p1Field->DeactivateField();
		//Trace::out("Swap to Field 2\n");
	}
		
}

