#ifndef MUSHROOM_FIELD_MANAGER_H
#define MUSHROOM_FIELD_MANAGER_H

#include "Game Components/TEAL/CommonElements.h"

class MushroomField;

class MushroomFieldManager
{
private:
	MushroomFieldManager();
	MushroomFieldManager(const MushroomFieldManager&) = default;
	MushroomFieldManager& operator=(const MushroomFieldManager&) = default;
	~MushroomFieldManager();
	static MushroomFieldManager* instance;
	static MushroomFieldManager& getInstance() {
		if (!instance)
			instance = new MushroomFieldManager();
		return *instance;
	}
private:
	//private reciever functions
	MushroomField* privGetCurrentField();
	void privCreateNewField();
	void privTerminate();
	void privNewGame();
	void privNewGameAI();
	void privRemoveMushroomFromCurrentField(sf::Vector2f);
	void privAddMushroomToCurrentField(sf::Vector2<char>);
	void privPoisonMushroomOnCurrentField(sf::Vector2<char>);
	bool privDoWeNeedAFlea();
	void privRegenerateCurrentField();
	void privRegenerateCurrentColumn(int);
	void privUpdateCurrentField();
	void privNewRound();
public:
	static MushroomField* GetCurrentField() { return getInstance().privGetCurrentField(); }
	static void CreateNewField() { getInstance().privCreateNewField(); }
	static void Terminate() { getInstance().privTerminate(); }
	static void NewGame() { getInstance().privNewGame(); }
	static void NewGameAI() { getInstance().privNewGameAI(); }
	static void RemoveMushroomFromCurrentField(sf::Vector2f pos) { getInstance().privRemoveMushroomFromCurrentField(pos); }
	static void AddMushroomToCurrentField(sf::Vector2<char> pos) { getInstance().privAddMushroomToCurrentField(pos); }
	static void PoisonMushroomOnCurrentField(sf::Vector2<char> pos) { getInstance().privPoisonMushroomOnCurrentField(pos); }
	static bool DoWeNeedAFlea() { return getInstance().privDoWeNeedAFlea(); }
	static void RegenerateCurrentField() { getInstance().privRegenerateCurrentField(); }
	static void RegenerateCurrentColumn(int col) { getInstance().privRegenerateCurrentColumn(col); }
	static void UpdateCurrentField() { getInstance().privUpdateCurrentField(); }
	static void NewRound() { getInstance().privNewRound(); }
	//public static accessor functions
private:
	//members
	MushroomField* pCurrentField;
	MushroomField* p1Field;
	MushroomField* p2Field;
};

#endif