#ifndef MUSHROOM_OBJECT_POOL_H
#define MUSHROOM_OBJECT_POOL_H

#include "Game Components/TEAL/CommonElements.h"
#include "Mushroom.h"
#include <stack>

class MushroomField;
class Mushroom;


class MushroomObjectPool
{
private:
	MushroomObjectPool();
	MushroomObjectPool(const MushroomObjectPool&) = delete;
	MushroomObjectPool& operator=(const MushroomObjectPool&) = delete;
	~MushroomObjectPool();
	static MushroomObjectPool* instance;
	static MushroomObjectPool& getInstance() {
		if (!instance)
			instance = new MushroomObjectPool();
		return *instance;
	}
private:
	//private non-static functions
	Mushroom* privGetMushroom();
	void privRecycleMushroom(Mushroom*);
	void privTerminate();
public:
	static Mushroom* getMushroom() { return getInstance().privGetMushroom(); }
	static void recycleMushroom(Mushroom* ms) { getInstance().privRecycleMushroom(ms); }
	static void Terminate() { getInstance().privTerminate(); }
private:
	std::stack<Mushroom*> recycledMushrooms;
};

#endif
