#include "OffsetCollection.h"
#include "Offsets.h"

const Offsets *OffsetCollection::StraightRight = new Offsets(OFFSET_TYPE::STRAIGHT_RIGHT);
const Offsets *OffsetCollection::StraightLeft = new Offsets(OFFSET_TYPE::STRAIGHT_LEFT);
const Offsets *OffsetCollection::TurnUpEndRight = new Offsets(OFFSET_TYPE::TURN_UP_RIGHT);
const Offsets *OffsetCollection::TurnDownEndRight = new Offsets(OFFSET_TYPE::TURN_DOWN_RIGHT);
const Offsets *OffsetCollection::TurnUpEndLeft = new Offsets(OFFSET_TYPE::TURN_UP_LEFT);
const Offsets *OffsetCollection::TurnDownEndLeft = new Offsets(OFFSET_TYPE::TURN_DOWN_LEFT);


const Offsets* OffsetCollection::Halt = new Offsets(OFFSET_TYPE::HALT);

const sf::Vector2<char> OffsetCollection::StraightRight_g = sf::Vector2<char>(1, 0);
const sf::Vector2<char> OffsetCollection::StraightLeft_g = sf::Vector2<char>(-1, 0);
const sf::Vector2<char> OffsetCollection::TurnUpEndRight_g = sf::Vector2<char>(0, -1);
const sf::Vector2<char> OffsetCollection::TurnDownEndRight_g = sf::Vector2<char>(0, 1);
const sf::Vector2<char> OffsetCollection::TurnUpEndLeft_g = sf::Vector2<char>(0, -1);
const sf::Vector2<char> OffsetCollection::TurnDownEndLeft_g = sf::Vector2<char>(0, 1);
const sf::Vector2<char> OffsetCollection::Halt_g = sf::Vector2<char>(0,0);

OffsetCollection::~OffsetCollection() {
	
}

void OffsetCollection::Terminate() {
	delete StraightRight;
	delete StraightLeft;
	delete TurnUpEndLeft;
	delete TurnDownEndLeft;
	delete TurnUpEndRight;
	delete TurnDownEndRight;
	delete Halt;
}

