#include "Offsets.h"
#include "Definitions.h"
#include "WaveManager.h"
#include "Wave.h"




//Offsets::Offsets(OFFSET_TYPE type) {
//	int frames = WaveManager::GetCurrentWave()->getFramesPerUpdate();
//	sf::Vector2f* tempArray = new sf::Vector2f[frames];
//	offsetArray = new sf::Vector2f[frames];
//	switch (type) {
//	case STRAIGHT_RIGHT:
//		for (int i = 0; i < frames; i++) {
//			offsetArray[i].x = (float)(WaveManager::GetCurrentWave()->getCentipedeSpeed());
//			offsetArray[i].y = 0.0f;
//		}
//		break;
//	case STRAIGHT_LEFT:
//		for (int i = 0; i < frames; i++) {
//			offsetArray[i].x = (float)(-WaveManager::GetCurrentWave()->getCentipedeSpeed());
//			offsetArray[i].y = 0.0f;
//		}
//		break;
//	case HALT:
//		for (int i = 0; i < frames; i++) {
//			offsetArray[i].x = 0.0f;
//			offsetArray[i].y = 0.0f;
//		}
//		break;
	//case TURN_UP_RIGHT:
	//	for (int k = 0; k < frames; k++) {
	//		tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f - k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f - k * (cn::PI / frames)));
	//	}
	//	for (int i = 0; i < frames - 1; i++) {
	//		offsetArray[i].x = tempArray[i + 1].x - tempArray[i].x;
	//		offsetArray[i].y = -(tempArray[i + 1].y - tempArray[i].y);
	//	}
	//	offsetArray[frames - 1].x = -tempArray[frames - 1].x;
	//	offsetArray[frames - 1].y = -((cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y);
	//	break;
	//case TURN_UP_LEFT:
	//	for (int k = 0; k < frames; k++) {
	//		tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f + k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f + k * (cn::PI / frames)));
	//	}
	//	for (int i = 0; i < frames - 1; i++) {
	//		offsetArray[i].x = tempArray[i + 1].x - tempArray[i].x;
	//		offsetArray[i].y = -(tempArray[i + 1].y - tempArray[i].y);
	//	}
	//	offsetArray[frames - 1].x = -tempArray[frames - 1].x;
	//	offsetArray[frames - 1].y = -((cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y);
	//	break;
	//case TURN_DOWN_RIGHT:
	//	for (int k = 0; k < frames; k++) {
	//		tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f - k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f - k * (cn::PI / frames)));
	//	}
	//	for (int i = 0; i < frames - 1; i++) {
	//		offsetArray[i].x = tempArray[i + 1].x - tempArray[i].x;
	//		offsetArray[i].y = tempArray[i + 1].y - tempArray[i].y;
	//	}
	//	offsetArray[frames - 1].x = -tempArray[frames - 1].x;
	//	offsetArray[frames - 1].y = (cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y;
	//	break;
	//case TURN_DOWN_LEFT:
	//	for (int k = 0; k < frames; k++) {
	//		tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE/2.0f * cosf(-cn::PI / 2.0f + k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE/2 + cn::CENTIPEDE_SEGMENT_SIZE/2 * sinf(-cn::PI / 2.0f + k * (cn::PI / frames)));
	//	}
	//	for (int i = 0; i < frames - 1; i++) {
	//		offsetArray[i].x = tempArray[i + 1].x - tempArray[i].x;
	//		offsetArray[i].y = tempArray[i + 1].y - tempArray[i].y;
	//	}
	//	offsetArray[frames - 1].x = -tempArray[frames - 1].x;
	//	offsetArray[frames - 1].y = (cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y;
	//	break;
	//default:
	//	// this should never happen
	//	assert(0 == 1);
	//	break;
	//}
	//delete[] tempArray;
//}

Offsets::Offsets(OFFSET_TYPE type) {
	offsetArray = new sf::Vector2f * [cn::SPEED_COUNT];
	for (int i = 0; i < cn::SPEED_COUNT; i++) {
		offsetArray[i] = new sf::Vector2f [(int)pow(2, cn::SPEED_COUNT - 1 - i)];
	}
	for (int spd = 0; spd < cn::SPEED_COUNT; spd++) {
		int frames = (int)powl(2, cn::SPEED_COUNT - 1 - spd);
		sf::Vector2f* tempArray = new sf::Vector2f[frames];
		switch (type) {
		case STRAIGHT_RIGHT:
			for (int i = 0; i < frames; i++) {
				offsetArray[spd][i].x = (float)(cn::PLAYER_SIZE / frames);
				offsetArray[spd][i].y = 0.0f;
			}
			break;
		case STRAIGHT_LEFT:
			for (int i = 0; i < frames; i++) {
				offsetArray[spd][i].x = -(float)(cn::PLAYER_SIZE / frames);
				offsetArray[spd][i].y = 0.0f;
			}
			break;
		case HALT:
			for (int i = 0; i < frames; i++) {
				offsetArray[spd][i].x = 0.0f;
				offsetArray[spd][i].y = 0.0f;
			}
			break;
		case TURN_UP_RIGHT:
			for (int k = 0; k < frames; k++) {
				tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f - k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f - k * (cn::PI / frames)));
			}
			for (int i = 0; i < frames - 1; i++) {
				offsetArray[spd][i].x = tempArray[i + 1].x - tempArray[i].x;
				offsetArray[spd][i].y = -(tempArray[i + 1].y - tempArray[i].y);
			}
			offsetArray[spd][frames - 1].x = -tempArray[frames - 1].x;
			offsetArray[spd][frames - 1].y = -((cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y);
			break;
		case TURN_UP_LEFT:
			for (int k = 0; k < frames; k++) {
				tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f + k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f + k * (cn::PI / frames)));
			}
			for (int i = 0; i < frames - 1; i++) {
				offsetArray[spd][i].x = tempArray[i + 1].x - tempArray[i].x;
				offsetArray[spd][i].y = -(tempArray[i + 1].y - tempArray[i].y);
			}
			offsetArray[spd][frames - 1].x = -tempArray[frames - 1].x;
			offsetArray[spd][frames - 1].y = -((cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y);
			break;
		case TURN_DOWN_RIGHT:
			for (int k = 0; k < frames; k++) {
				tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f - k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f - k * (cn::PI / frames)));
			}
			for (int i = 0; i < frames - 1; i++) {
				offsetArray[spd][i].x = tempArray[i + 1].x - tempArray[i].x;
				offsetArray[spd][i].y = tempArray[i + 1].y - tempArray[i].y;
			}
			offsetArray[spd][frames - 1].x = -tempArray[frames - 1].x;
			offsetArray[spd][frames - 1].y = (cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y;
			break;
		case TURN_DOWN_LEFT:
			for (int k = 0; k < frames; k++) {
				tempArray[k] = sf::Vector2f(cn::CENTIPEDE_SEGMENT_SIZE / 2.0f * cosf(-cn::PI / 2.0f + k * (cn::PI / frames)), cn::CENTIPEDE_SEGMENT_SIZE / 2 + cn::CENTIPEDE_SEGMENT_SIZE / 2 * sinf(-cn::PI / 2.0f + k * (cn::PI / frames)));
			}
			for (int i = 0; i < frames - 1; i++) {
				offsetArray[spd][i].x = tempArray[i + 1].x - tempArray[i].x;
				offsetArray[spd][i].y = tempArray[i + 1].y - tempArray[i].y;
			}
			offsetArray[spd][frames - 1].x = -tempArray[frames - 1].x;
			offsetArray[spd][frames - 1].y = (cn::CENTIPEDE_SEGMENT_SIZE) - tempArray[frames - 1].y;
			break;
		default:
			// this should never happen
			assert(0 == 1);
			break;
		}
		delete[] tempArray;
	}
}

const sf::Vector2f &Offsets::getOffset(int num, int speed) const {
	return this->offsetArray[speed][num];
}

Offsets::~Offsets() {
	for (int i = 0; i < cn::SPEED_COUNT; i++)
		delete[] offsetArray[i];
	delete[] offsetArray;
}