#ifndef PROFILE_H
#define PROFILE_H

#include "Game Components/TEAL/CommonElements.h"
#include "InputController.h"
#include "Ship.h"


class MushroomField;
class Bullet;

class Profile
{
public:
	Profile();
	Profile(const Profile&) = default;
	Profile& operator=(const Profile&) = default;
	~Profile();

	void Initialize();
	void Terminate();

	void LoseOneLife();
	bool stillAlive() { return lives_remaining > 0 ? true : false; }
	void addScore(int);
	void printScore() { Trace::out("Score: %d\n", score); }
	int getScore() { return score; }
	void AdvanceWave() { wave_id++; }
	bool AchievedBonus();
	void AddOneLife();
	bool moveLeft() { return pShip->moveLeft(); }
	bool moveRight() { return pShip->moveRight();}
	bool moveUp() { return pShip->moveUp(); }
	bool moveDown() { return pShip->moveDown(); }
	void Shoot();
	void RemoveFromScreen() { pShip->RemoveFromScreen(); }
	sf::Vector2f GetShipPositon();

	void EndRound();
	void NewRound();
	void NewGame();

	void Kill() { lives_remaining = 0; }

	void FillBulletRequest(Bullet*);

	int GetFieldID() { return field_id; }
	void SetFieldID(int v) { field_id = v; }

	int GetWave() { return wave_id; }

	void ResetScore() { score = 0; }
private:
	//private member variables
	int lives_remaining;
	int wave_id;
	int score;
	CONTROLLER_TYPE controller_type;
	int field_id;
	Ship* pShip;
	Bullet* attachedBullet;

	int bonus_count;


};

#endif