#include "ProfileManager.h"
#include "Profile.h"

ProfileManager::ProfileManager() {
	pCurrentPlayer = nullptr;
	pPlayer1 = new Profile();
	pPlayer1->SetFieldID(1);
	pPlayer2 = new Profile();
	pPlayer2->SetFieldID(2);
	pPlayerAI = new Profile();
}

void ProfileManager::privInitialize1P() {
	pPlayer2->RemoveFromScreen();
	pPlayerAI->RemoveFromScreen();
	pCurrentPlayer = pPlayer1;
	pPlayer1->Initialize();
	pPlayer2->Kill();
}

void ProfileManager::privInitialize2P() {
	pPlayer2->RemoveFromScreen();
	pPlayerAI->RemoveFromScreen();
	pCurrentPlayer = pPlayer1;
	pPlayer1->Initialize();
	pPlayer2->Initialize();
}

void ProfileManager::privInitializeAI() {
	pPlayer2->RemoveFromScreen();
	pPlayer1->RemoveFromScreen();
	pCurrentPlayer = pPlayerAI;
}

void ProfileManager::privRemoveAllProfiles() {
	//pCurrentPlayer = nullptr;
}

void ProfileManager::privSwapActivePlayers() {
	if (pCurrentPlayer == pPlayer1) {
		if (pPlayer2->stillAlive()) {
			pCurrentPlayer = pPlayer2;
		}
	}
	else {
		if (pPlayer1->stillAlive()) {
			pCurrentPlayer = pPlayer1;
		}
	}
		
}

ProfileManager* ProfileManager::instance = nullptr;

bool ProfileManager::privExistsLivePlayer() {
	if (pCurrentPlayer == pPlayerAI) return true; else return (pPlayer1->stillAlive() || pPlayer2->stillAlive());
}

bool ProfileManager::privCurrentPlayerBonus() {
	return (pCurrentPlayer)->AchievedBonus();
}

void ProfileManager::privNewGame() {
	pPlayer1->EndRound();
	pPlayer2->EndRound();
	pPlayerAI->EndRound();
}

void ProfileManager::privTerminate() {
	(pCurrentPlayer)->Terminate();
	delete instance;
}

ProfileManager::~ProfileManager() {
	//change
	delete pPlayer1;
	delete pPlayer2;
	delete pPlayerAI;
}

void ProfileManager::privBonusLife() {
	(pCurrentPlayer)->AddOneLife();
}

void ProfileManager::privEndRound() {
	//this should actually check if profiles need to be swapped.
	(pCurrentPlayer)->EndRound();
}

void ProfileManager::privNewRound() {
	(pCurrentPlayer)->NewRound();
}

int ProfileManager::privGetFieldIdFromCurrentPlayer() {
	return pCurrentPlayer->GetFieldID();
}

void ProfileManager::privNewWave() {
	this->pCurrentPlayer->AdvanceWave();
}