#ifndef PROFILE_MANAGER_H
#define PROFILE_MANAGER_H

#include "Game Components/TEAL/CommonElements.h"
#include "Profile.h"

class ProfileManager
{
private:
	ProfileManager();
	ProfileManager(const ProfileManager&) = delete;
	ProfileManager& operator=(const ProfileManager&) = delete;
	~ProfileManager();
	static ProfileManager* instance;
	static ProfileManager& getInstance() {
		if (!instance)
			instance = new ProfileManager();
		return *instance;
	}
public:
	//public static functions
	static Profile* GetCurrentPlayer() { return getInstance().privGetCurrentPlayer(); }
	static bool ExistsLivePlayer() { return getInstance().privExistsLivePlayer(); }
	static void NewGame() { getInstance().privNewGame(); }
	static void EndRound() { getInstance().privEndRound(); }
	static void NewRound() { getInstance().privNewRound(); }
	static void Terminate() { getInstance().privTerminate(); }
	static bool CurrentPlayerBonus(){ return getInstance().privCurrentPlayerBonus(); }
	static void BonusLife() { getInstance().privBonusLife(); }
	static void Initialize1P() { getInstance().privInitialize1P(); }
	static void Initialize2P() { getInstance().privInitialize2P(); }
	static void InitializeAI() { getInstance().privInitializeAI(); }
	static void RemoveAllProfiles() { getInstance().privRemoveAllProfiles(); }
	static void SwapActivePlayers() { getInstance().privSwapActivePlayers(); }
	static int GetFieldIDFromCurrentPlayer() { return getInstance().privGetFieldIdFromCurrentPlayer(); }
	static void NewWave() { getInstance().privNewWave(); }
	static int GetPlayer1Score() { return getInstance().pPlayer1->getScore(); }
	static int GetPlayer2Score() { return getInstance().pPlayer2->getScore(); }
	static void ResetPlayer1Score() { return getInstance().pPlayer1->ResetScore(); }
private:
	//private non-static functions
	Profile* privGetCurrentPlayer() { return pCurrentPlayer; }
	bool privExistsLivePlayer();
	void privNewGame();
	void privTerminate();
	bool privCurrentPlayerBonus();
	void privBonusLife();

	void privEndRound();
	void privNewRound();
	void privNewWave();

	void privInitialize1P();
	void privInitialize2P();
	void privInitializeAI();

	void privRemoveAllProfiles();
	void privSwapActivePlayers();

	int privGetFieldIdFromCurrentPlayer();
private:
	//member variables
	Profile* pCurrentPlayer;
	Profile* pPlayer1;
	Profile* pPlayer2;
	Profile* pPlayerAI;
};

#endif

