#ifndef SCORE_DISPLAY_H
#define SCORE_DISPLAY_H

#include "Game Components/TEAL/CommonElements.h"
#include "ScoreFont.h"
#include "SpriteString.h"
#include <string>
#include <list>

class Glyph;


class ScoreDisplay
{
private:
	ScoreDisplay();
	ScoreDisplay(const ScoreDisplay&) = default;
	ScoreDisplay& operator=(const ScoreDisplay&) = default;
	~ScoreDisplay() = default;
	static ScoreDisplay* instance;
	static ScoreDisplay& getInstance() {
		if (!instance)
			instance = new ScoreDisplay();
		return *instance;
	}

	void privUpdateScoreP1(int);
	void privUpdateLivesP1(int);
	void privUpdateScoreP2(int);
	void privUpdateLivesP2(int);
	void privDrawP1();
	void privDrawP2();
	void privDrawAttractor();
	void privDrawMiscText();
	void privTerminate();
	void privUpdateHighScores();
	void privDrawNewHSMode();
	void privProcessInitials(sf::Uint32);
	void privResetHighScoreText();
public:
	static void UpdateScoreP1(int obj) { getInstance().privUpdateScoreP1(obj);}
	static void UpdateLivesP1(int obj) { getInstance().privUpdateLivesP1(obj);}
	static void UpdateScoreP2(int obj) { getInstance().privUpdateScoreP2(obj);}
	static void UpdateLivesP2(int obj) { getInstance().privUpdateLivesP2(obj);}
	static void DrawP1() { getInstance().privDrawP1(); }
	static void DrawP2() { getInstance().privDrawP2(); }
	static void DrawAttractor() { getInstance().privDrawAttractor(); }
	static void DrawMiscText() { getInstance().privDrawMiscText(); }
	static void DrawNewHSMode() { getInstance().privDrawNewHSMode(); }
	static void Terminate() { getInstance().privTerminate(); }
	static void UpdateHighScores() { getInstance().privUpdateHighScores(); }
	static void ProcessInitials(sf::Uint32 uint) { getInstance().privProcessInitials(uint); }
	static void ResetHighScoreText() { getInstance().privResetHighScoreText(); }
private:
	ScoreFont sFont;
	/*std::list<Glyph> p1Symbols;
	std::list<Glyph> p1LifeSymbols;
	std::list<Glyph> p2Symbols;
	std::list<Glyph> p2LifeSymbols;
	std::list<Glyph> DemoText;
	sf::Vector2f p1DisplayPos;
	sf::Vector2f p1LifePos;
	sf::Vector2f p2DisplayPos;
	sf::Vector2f p2LifePos;
	std::string scoreText;
	std::string DemoTextString;
	std::string DemoHSString;*/
	SpriteString p1Score;
	SpriteString p2Score;
	SpriteString p1Lives;
	SpriteString p2Lives;
	SpriteString FooterText;
	SpriteString HSDemoText;
	SpriteString HighScoresHeaderText;
	std::list<SpriteString> HighScoresText;
	SpriteString CreditsText;
	SpriteString BonusText;
	SpriteString GameOverText;
	SpriteString GreatScoreText;
	SpriteString EnterYourInitialsText;
	SpriteString InitialsText;
	size_t initials_it;
};

#endif

