#include "Ship.h"
#include "Definitions.h"
#include "Mushroom.h"
#include <math.h>
#include "GameManager.h"



Ship::Ship() {
	this->bitmap = &ResourceManager::GetTextureBitmap("playerSprite");
	this->cSprite = sf::Sprite(ResourceManager::GetTexture("playerSprite"));

	this->SetDrawOrder(10);
	this->SetUpdateOrder(0);

	this->player_speed = cn::PLAYER_SPEED;

	this->pos.x = -100.0f;
	this->pos.y = -100.0f;
	
	SetCollider(this->cSprite, *bitmap);
	RegisterCollision<Ship>(*this);
}

Ship::~Ship() {

}

void Ship::NewRound() {
	pos = sf::Vector2f(cn::PLAYER_SPAWN_HORIZONTAL_POS, cn::PLAYER_SPAWN_HEIGHT_POS);
	this->player_speed = cn::PLAYER_SPEED;
}

void Ship::NewGame() {
	
}

void Ship::EndRound() {
	this->pos = sf::Vector2f(-1000.0f, -1000.0f);
	this->player_speed = 0;
}

void Ship::Update() {
	this->pos += this->vel;
	this->prevVel = this->vel;
	this->vel.x = 0;
	this->vel.y = 0;
	this->cSprite.setPosition(this->pos);
}

bool Ship::moveUp() {
	if (this->pos.y > cn::PLAYER_HEIGHT_LIMIT) {
		this->vel.y -= player_speed;
		return true;
	}
	else return false;
		
}

bool Ship::moveDown() {
	if (this->pos.y < (float)(cn::SCREEN_HEIGHT - 2 * cn::PLAYER_SIZE)) {
		this->vel.y += player_speed;
		return true;
	}
	else return false;
		
}

bool Ship::moveLeft() {
	if (this->pos.x > 0) {
		this->vel.x -= player_speed;
		return true;
	}
	else return false;
}

bool Ship::moveRight() {
	if (this->pos.x < (float)(cn::SCREEN_WIDTH - cn::PLAYER_SIZE)) {
		this->vel.x += player_speed; 
		return true;
	}
	else return false;
}

void Ship::Draw() {
	WindowManager::Window().draw(this->cSprite);
}

void Ship::Destroy() {
	DeregisterCollision<Ship>(*this);
}

sf::Vector2f Ship::getPos() {
	return this->pos;
}

void Ship::Collision(Mushroom* other) {
	sf::Vector2f rel(fabsf(this->pos.x - other->getPos().x), fabsf(this->pos.y - other->getPos().y));
	if (rel.x < cn::MUSHROOM_BOUNDING_BOX_WIDTH)
		this->pos.x -= this->prevVel.x;
	if (rel.y < cn::MUSHROOM_BOUNDING_BOX_HEIGHT)
		this->pos.y -= this->prevVel.y;
	this->cSprite.setPosition(this->pos);
}

void Ship::Collision(Flea* other) {
	GameManager::NewRound();
}

void Ship::Collision(Spider* other) {
	GameManager::NewRound();
}

void Ship::Collision(CentipedeBody* other) {
	GameManager::NewRound();
}

void Ship::Collision(CentipedeHead* other) {
	GameManager::NewRound();
}

