#ifndef SHIP_H
#define SHIP_H

#include "Game Components/TEAL/CommonElements.h"

class Mushroom;
class Flea;
class Spider;
class CentipedeBody;
class CentipedeHead;

class Ship : public GameObject
{
public:
	Ship();
	Ship(const Ship&) = default;
	Ship& operator=(const Ship&) = default;
	~Ship();

	virtual void Draw();
	virtual void Update();
	virtual void Destroy();
	virtual void Collision(GameObject* go) {}
	
	void Collision(Mushroom*);
	void Collision(Flea*);
	void Collision(Spider*);
	void Collision(CentipedeBody*);
	void Collision(CentipedeHead*);

	sf::Vector2f getPos();
	bool moveUp();
	bool moveDown();
	bool moveLeft();
	bool moveRight();

	

	void NewGame();
	void EndRound();
	void NewRound();

	void RemoveFromScreen() { this->pos.x = -100.0f; this->pos.y = -100.0f; }
private:
	sf::Vector2f pos;
	sf::Vector2f vel;
	sf::Vector2f prevVel;
	sf::Sprite cSprite;
	CollisionTools::TextureBitmap* bitmap;
	float player_speed;

};

#endif