#ifndef SPRITE_STRING_H
#define SPRITE_STRING_H

#include "Game Components/TEAL/CommonElements.h"
#include <list>
#include <string>
#include "Glyph.h"

class SpriteString
{
public:
	enum class DRAW_DIRECTION : unsigned char {
		FORWARD,
		BACKWARD
	};
	SpriteString() = default;
	SpriteString(const SpriteString&) = default;
	SpriteString& operator=(const SpriteString&) = default;
	~SpriteString() = default;

	SpriteString(std::string, sf::Vector2f, GlyphSheet*, DRAW_DIRECTION);

	void GenerateSymbolList();
	void Draw();
	void UpdateString(std::string);
	void UpdatePosition(sf::Vector2f);
	void UpdateDirection(DRAW_DIRECTION);
	std::string GetString() { return stringText; }
	
private:
	std::string stringText;
	std::list<Glyph> stringSymbols;
	sf::Vector2f init_pos;
	DRAW_DIRECTION stringDirection;

	GlyphSheet* stringFont;

};

#endif